#include <stdio.h>
#include <stdlib.h>
#include "polinomio.h"

/*
 * Costruisce un nuovo polinomio di grado 2 con i coefficienti indicati. 
 */
struct polinomio *construct(int a, int b, int c) {
  struct polinomio *this = (struct polinomio *) malloc(sizeof(struct polinomio));
  this->a = a;
  this->b = b;
  this->c = c;

  return this;
}

/*
 * Dealloca il polinomio indicato.
 */
void destruct_polinomio(struct polinomio *this) {
  free(this);
}

/*
 * Restituisce il grado del polinomio indicato.
 */
int grado(struct polinomio *this) {
  if (this->a != 0)
    return 2;
  if (this->b != 0)
    return 1;
  return 0;
}

/*
 * Restituisce un nuovo polinomio che è la somma dei due polinomi indicati.
 */
struct polinomio *add(struct polinomio *this, struct polinomio *other) {
  
  return construct(this->a + other->a,
                    this->b + other->b,
                    this->c + other->c);
}

/*
 * Restituisce il valore del polinomio indicato valutato nel punto indicato.
 */
int evaluate(struct polinomio *this, int x) {

  return this->a * x * x + this->b * x + this->c;
}

/*
 * Stampa il polinomio indicato.
 */
void toString(struct polinomio *this) { 
  if (this->a > 0)
    printf(" + %dx^2", this->a);
  else if (this->a < 0)
    printf(" - %dx^2", -this->a);
  // se a == 0 non stampiamo il termine di grado 2

  if (this->b > 0)
    printf(" + %dx", this->b);
  else if (this->b < 0)
    printf(" - %dx", -this->b);
  // se b == 0 non stampiamo il termine di grado 1

  if (this->c > 0)
    printf(" + %d", this->c);
  else if (this->c < 0)
    printf(" - %d", -this->c);
  // se c == 0 non stampiamo il termine noto
}
