#include "stack.h"
#include <stdio.h>
#include <stdlib.h>

/**
 * Funzione che aggiunge un nuovo elemento allo stack.
 */
struct entry *push(struct entry *stack, int value) {
	struct entry *e = (struct entry *) malloc(sizeof(struct entry));
	e->value = value;
	e->next_value = stack;
	return e;
}

/**
 * Funzione che elimina l'elemento in cima allo stack.
 */
struct entry *pop(struct entry *stack) {
	if (stack != NULL) {
		struct entry *tmp = stack;
		stack = stack->next_value;
		free (tmp);  // viene liberata la memoria allocata al primo elemento!
	} 
	return stack;
}

/**
 * Funzione che restituisce l'elemento in cima allo stack
 */
int top (struct entry *stack) {
	if (stack != NULL)
		return stack->value;
	else
		return -1;
}
