#include <stdlib.h>
#include <stdbool.h>
#include <stdio.h>
#include "stack.h"
#include "iterator.h"

/*
 * Costruisce un nuovo iteratore per i primi length elementi dell'array arr.
 */
struct iterator *construct(int arr[], int length) {
  struct iterator *this = (struct iterator *) malloc(sizeof(struct iterator));
  struct entry *stack = NULL;
  int i;
  
  for (i = length - 1; i >= 0; i--)
  	stack = push(stack, arr[i]);
  	
  this->stack = stack;
  return this;
}

/*
 * Restituisce true se l'iteratore ha ancora elementi su cui iterare,
 * false altrimenti.
 */
bool hasNext(struct iterator *this) {
  return (this->stack) ;
}

/*
 * Restituisce il prossimo elemento dell'iteratore
 */
int next(struct iterator *this) {
  int val = top(this->stack);      // memorizziamo il valore
  this->stack = pop(this->stack);  // eliminiamo la entry
  return  val;                     // restituiamo il valore
}

